<?php
/*
Plugin Name: WP Headline
Author URI: http://coding-bereich.de/
Description: Adds Headline BBCodes to WordPress. Use: [hl=1-5]Headline[/hl] or [h=1-5]Headline[/h] 
Version: 0.3
Author: Thomas Heck
Plugin URI: http://coding-bereich.de/2010/03/31/allgemein/wordpress-plugin-wp-headline.html
*/


class WPHeadline
{
	var $_headlines = array();
	
	function WPHeadline()
	{
		add_filter('the_content', array($this, 'onTheContent'));
	}
	
	function onTheContent($content='')
	{
		$content = preg_replace_callback('/\[h(?:\s*=\s*(?P<1>[1-5]\s*))?\](?P<2>.*)\[\/h\]/imS', array($this, 'onH'), $content);
		$content = preg_replace_callback('/\[hl(?:\s*=\s*(?P<1>[1-5]\s*))?\](?P<2>.*)\[\/hl\]/imS', array($this, 'onHL'), $content);
		
		if( isset($this->_headlines[0]) )
		{
			$head = '<ul class="contentlist" style="list-style-type:none; background-color: #005555; border: 1px #000000 solid; float:right; margin:0px; padding:5px;">';
			foreach($this->_headlines as $h)
			{
				$head .= '<li style="padding-left: ' . (($h['level']-1)*15) . 'px; margin: 2px;"><a href="#' . $h['name'] . '">' . $h['title'] . '</a></li>';
			}
			$head .='</ul>';
			
			$content = $head . $content;
		}
		
		return $content;
	}
	
	function onH($in)
	{
		$h = 1;
		if( !empty($in[1]) )
			$h = $in[1];
		
		$title = $in[2];		
		
		return '<h' . ($h+1) . '>' . $title . '</h' . ($h+1) . '>';
	}
	
	function onHL($in)
	{
		$h = 1;
		if( !empty($in[1]) )
			$h = $in[1];
		
		$title = $in[2];
		
		$name = preg_replace('/\s+/mS', '_', $title);
		$name = preg_replace('/[^a-zA-Z0-9_]/mS', '', $name);
		$name = strtolower($name);
		
		$this->_headlines[] = array('title'=>$title, 'name'=>$name, 'level'=>$h);
		
		return '<h' . ($h+1) . ' id="' . $name . '">' . $title . '</h' . ($h+1) . '>';
	}
}

$wpHeadLine = new WPHeadLine();
?>
